<TeXmacs|1.0.7.20>

<style|<tuple|beamer|maxima|pari|mathemagix>>

<\body>
  <screens|<\shown>
    <\with|par-mode|center>
      <space|0cm|0cm|2.5fn><strong|<with|font-base-size|17|<strong|<with|color|dark
      green|GNU> <anim-repeat|<TeXmacs*>>>: a scientic editing platform>>

      by Joris van der Hoeven
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<image|texmacs-chip.ps|0.75w|0.75h||>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|cole
      Polytechnique 2007>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.texmacs.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Why <TeXmacs>?>

    A scientific editing platform combines:

    <\itemize>
      <unroll|<\shown>
        <\fold-back>
          <unroll|<\shown>
            <item>Polyvalent & user-friendly editors for scientific documents
            & data.
          </shown>|<\hidden*>
            -- Mathematical formulas.
          </hidden*>|<\hidden*>
            -- Technical pictures.
          </hidden*>|<\hidden*>
            -- Typed hyperlinks and annotations.
          </hidden*>>
        </fold-back>
      </shown>|<\hidden*>
        <\fold-back>
          <unroll|<\shown>
            <item>Possibility to interface the editor with a range of extern
            software.
          </shown>|<\hidden*>
            -- Interfaces with computer algebra systems.
          </hidden*>|<\hidden*>
            -- Tools for scientific visualization.
          </hidden*>|<\hidden*>
            -- Spell checker.
          </hidden*>>
        </fold-back>
      </hidden*>|<\hidden*>
        <\fold-back>
          <unroll|<\shown>
            <item>Common transversal editing tools.
          </shown>|<\hidden*>
            -- Integrated help system.
          </hidden*>|<\hidden*>
            -- Ergonomy and typesetting quality.
          </hidden*>|<\hidden*>
            -- Undo, redo, version control.
          </hidden*>|<\hidden*>
            -- Remote tools like a wiki.
          </hidden*>|<\hidden*>
            -- Presentation mode.
          </hidden*>|<\hidden*>
            -- Import/Export
          </hidden*>>
        </fold-back>
      </hidden*>|<\hidden*>
        <\fold-back>
          <unroll|<\shown>
            <item>Customization and extensability.
          </shown>|<\hidden*>
            -- User provided style files.
          </hidden*>|<\hidden*>
            -- Scriptability via an extension language.
          </hidden*>>
        </fold-back>
      </hidden*>>
    </itemize>

    \;
  </hidden>|<\hidden>
    <tit|First steps>

    <hlink|Example paper|galois.tm> (<action|<LaTeX> export|(system "emacs
    /Users/vanderhoeven/seminar/ICM06/galois.tex &")>, <action|after
    compilation|(system "gv /Users/vanderhoeven/seminar/ICM06/galois.ps &")>,
    <action|<name|Xhtml>/<name|MathML>|(system
    "/Applications/Firefox.app/Contents/MacOS/firefox
    /Users/vanderhoeven/seminar/ICM06/galois.xhtml &")>)

    <hlink|Concrete typing|empty.tm>

    <\itemize>
      <item>Style, language.

      <item>Title, section, theorem.

      <item>Mathematics, symbols, common constructs, matrices.

      <item><hlink|Graphics|graphics.tm>.

      <item><locus|<id|+Deu3lHGtRzULci>|<link|Example|<id|+Deu3lHGtRzULci>|<id|+Deu3lHGtRzULcm>>|<link|Example|<id|+Deu3lHGtRzULci>|<id|+Deu3lHGtRzULcr>>|Links>.
    </itemize>
  </hidden>|<\hidden>
    <tit|Computer algebra>

    <\session|maxima|default>
      <\folded>
        A simple <name|Maxima> session
      <|folded>
        <\input|<with|color|red|(C1) >>
          diff(x^x^x,x,3);
        </input>

        <\input|<with|color|red|(C2) >>
          expand(integrate(d1,x));
        </input>

        <\input|<with|color|red|(C4) >>
          \;
        </input>
      </folded>
    </session>

    <\session|maxima|default>
      <\folded>
        Mathematical input
      <|folded>
        <\input-math|<with|color|red|(C4) >>
          integrate<left|(><frac|x<rsup|5>+x-1|x<rsup|2>-3>,x<right|)>;
        </input-math>

        <\input-math|<with|color|red|(C7) >>
          expand<left|(>diff<left|(>-<frac|log
          <left|(><frac|2*x-2*<sqrt|3>|2*x+2*<sqrt|3>><right|)>|2*<sqrt|3>>+5*log
          <left|(>x<rsup|2>-3<right|)>+<frac|x<rsup|4>+6*x<rsup|2>|4>,x<right|)><right|)>;
        </input-math>

        <\input-math|<with|color|red|(C9) >>
          \;
        </input-math>
      </folded>
    </session>

    <\session|maxima|default>
      <\folded>
        Integrated documentation
      <|folded>
        <\input|<with|color|red|(C9) >>
          plot3d([cos(x)*(3+y*cos(x/2)),sin(x)*(3+y*cos(x/2)),y*sin(x/2)],

          \ \ \ [x,-%pi,%pi],[y,-1,1],['grid,50,15])
        </input>

        <\input-math|<with|color|red|(C10) >>
          \;
        </input-math>
      </folded>
    </session>

    <\session|pari|default>
      <\folded>
        Interoperability -- Pari side
      <|folded>
        <\input-math|pari] >
          (x+y+z)<rsup|10>
        </input-math>

        <\input-math|pari] >
          \;
        </input-math>
      </folded>
    </session>

    <\session|maxima|default>
      <\folded>
        Interoperability -- Maxima side
      <|folded>
        <\input-math|<with|color|red|(C9) >>
          \;
        </input-math>
      </folded>
    </session>
  </hidden>|<\hidden>
    <tit|Computer algebra in the background>

    <unroll|<\shown>
      Computer-aided typing

      Hallo <math|1+1>

      <\equation*>
        <left|(><tabular*|<tformat|<table|<row|<cell|1>|<cell|1>|<cell|1>>|<row|<cell|a>|<cell|b>|<cell|c>>|<row|<cell|a<rsup|2>>|<cell|b<rsup|2>>|<cell|c<rsup|2>>>>>><right|)>
      </equation*>
    </shown>|<\hidden*>
      Graphics

      <plot-surface|sin(x+y<rsup|2>)|\<um\>2*\<mathpi\>|2*\<mathpi\>|\<um\>2|2>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|<name|Mathemagix> / <name|Mmxlib> \ (future)>

    <with|gr-mode|<tuple|group-edit|zoom>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.499999gh>>|gr-geometry|<tuple|geometry|0.999977par|0.483302par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-fill-color|pastel
    yellow|arrow-length|10ln|arrow-height|6ln|<graphics|<with|fill-color|pastel
    yellow|magnify|1.90218726191909|<cline|<point|0.742283328118856|2.03805778062759>|<point|4.13904629583151|2.03805778062759>|<point|4.13904629583151|3.39676296771265>|<point|0.742283328118856|3.39676296771265>>>|<with|fill-color|pastel
    yellow|magnify|1.90218726191909|<cline|<point|0.742283328118856|-2.03805778062759>|<point|0.742283328118856|-3.39676296771265>|<point|4.13904629583151|-3.39676296771265>|<point|4.13904629583151|-2.03805778062759>>>|<point|6.85645667000162|-2.71741037417012>|<point|6.85645667000162|2.71741037417012>|<point|6.17710407645909|2.71741037417012>|<with|text-at-halign|center|text-at-valign|center|magnify|1.22402190421497|<text-at|Python|<point|2.44066481197518|2.71741037417012>>>|<with|fill-color|pastel
    yellow|magnify|1.90218726191909|<cline|<point|-7.4099477943915|2.03805778062759>|<point|-4.01318482667885|2.03805778062759>|<point|-4.01318482667885|3.39676296771265>|<point|-7.4099477943915|3.39676296771265>>>|<with|text-at-halign|center|text-at-valign|center|magnify|1.14049776198795|<text-at|Mathemagix|<point|-5.71156631053518|2.71741037417012>>>|<with|fill-color|pastel
    yellow|magnify|1.90218726191909|<cline|<point|-3.33383223313632|-2.03805778062759>|<point|-3.33383223313632|-3.39676296771265>|<point|0.0629307345763262|-3.39676296771265>|<point|0.0629307345763262|-2.03805778062759>>>|<point|5.49775148291656|2.71741037417012>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|5.49775148291656|-2.03805778062759>|<point|2.10098851520392|-0.67935259354253>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|-0.616421858966204|0.67935259354253>|<point|-1.63545074928|2.03805778062759>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|-1.63545074928|-2.03805778062759>|<point|-0.616421858966204|-0.67935259354253>>>|<point|6.17710407645909|-2.71741037417012>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|0.742283328118856|0.67935259354253>|<point|2.44066481197518|2.03805778062759>>>|<with|fill-color|pastel
    blue|magnify|1.90218726191909|<cline|<point|-1.97512704605126|0.67935259354253>|<point|2.10098851520392|0.67935259354253>|<point|2.10098851520392|-0.67935259354253>|<point|-1.97512704605126|-0.67935259354253>>>|<with|text-at-halign|center|text-at-valign|center|magnify|1.11871492404351|<text-at|Mmxlib
    kernel|<point|0.0629307345763262|0.0>>>|<with|fill-color|pastel
    yellow|magnify|1.90218726191909|<cline|<point|-7.4099477943915|-2.03805778062759>|<point|-4.01318482667885|-2.03805778062759>|<point|-4.01318482667885|-3.39676296771265>|<point|-7.4099477943915|-3.39676296771265>>>|<with|text-at-halign|center|text-at-valign|center|magnify|1.54846589153109|<text-at|Mmxlib|<point|-5.71156631053518|-2.71741037417012>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|-5.71156631053518|-2.03805778062759>|<point|-1.97512704605126|-0.67935259354253>>>|<point|5.49775148291656|-2.71741037417012>|<with|text-at-halign|center|text-at-valign|center|magnify|1.46172641892751|<text-at|Synaps|<point|2.44066481197518|-2.71741037417012>>>|<with|text-at-halign|center|text-at-valign|center|magnify|1.5502229640975|<text-at|Gmp|<point|-1.63545074928|-2.71741037417012>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|2.10098851520392|0.67935259354253>|<point|5.49775148291656|2.03805778062759>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|2.44066481197518|-2.03805778062759>|<point|0.742283328118856|-0.67935259354253>>>|<with|fill-color|pastel
    yellow|magnify|1.90218726191909|<cline|<point|-3.33383223313632|2.03805778062759>|<point|0.0629307345763262|2.03805778062759>|<point|0.0629307345763262|3.39676296771265>|<point|-3.33383223313632|3.39676296771265>>>|<with|text-at-halign|center|text-at-valign|center|magnify|1.26918918753696|<text-at|Scheme|<point|-1.63545074928|2.71741037417012>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|1.90218726191909|<line|<point|-1.97512704605126|0.67935259354253>|<point|-5.71156631053518|2.03805778062759>>>>>
  </hidden>|<\hidden>
    <tit|<name|Mmxlib> / <name|Mathemagix>>

    <\fold-back>
      <\session|mathemagix|default>
        <\folded>
          Effective real numbers
        <|folded>
          <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
            x:Real\<longequal\>sin sin real 2;
          </input-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            x
          <|folded-io-math>
            <math|7.891*10<rsup|\<um\>1>> <right-flush>
            <math|<with|color|brown|mode|text|Real>>
          </folded-io-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            approximate(x,1.0e\<um\>35);
          <|folded-io-math>
            <math|7.8907234357288836143140304248688412*10<rsup|\<um\>1>>
            <right-flush> <math|<with|color|brown|mode|text|Interval>>
          </folded-io-math>

          <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
            \;
          </input-math>
        </folded>

        <\folded>
          Effective real numbers inside other data structures
        <|folded>
          <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
            M:Matrix Real\<longequal\><matrix|<tformat|<table|<row|<cell|x>|<cell|x+2>>|<row|<cell|2-x<rsup|2>>|<cell|cos
            x>>>>>;
          </input-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            M;
          <|folded-io-math>
            <math|<left|[><tabular*|<tformat|<table|<row|<cell|7.891*10<rsup|\<um\>1>>|<cell|2.789>>|<row|<cell|1.377>|<cell|7.045*10<rsup|\<um\>1>>>>>><right|]>>
            <right-flush> <math|<with|color|brown|<text|Matrix><left|(><text|Real><right|)>>>
          </folded-io-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            M<rsup|20>;
          <|folded-io-math>
            <math|<left|[><tabular*|<tformat|<table|<row|<cell|2.284*10<rsup|8>>|<cell|3.181*10<rsup|8>>>|<row|<cell|1.571*10<rsup|8>>|<cell|2.188*10<rsup|8>>>>>><right|]>>
            <right-flush> <math|<with|color|brown|<text|Matrix><left|(><text|Real><right|)>>>
          </folded-io-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            approximate((M<rsup|20>)[0,0],1.0e-50)
          <|folded-io-math>
            <math|2.284345992885219338517232854301132836637959531085432615615*10<rsup|8>>
            <right-flush> <math|<with|color|brown|mode|text|Interval>>
          </folded-io-math>

          <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
            \;
          </input-math>
        </folded>

        <\session|mathemagix|default>
          <\folded>
            Effective analytic functions
          <|folded>
            <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
              z:Analytic\<longequal\>analytic (0,1);
            </input-math>

            <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
              exp(z);
            <|folded-io-math>
              <math|1.000+1.000*z+5.000*10<rsup|\<um\>1>*z<rsup|2>+1.667*10<rsup|\<um\>1>*z<rsup|3>+4.167*10<rsup|\<um\>2>*z<rsup|4>+8.333*10<rsup|\<um\>3>*z<rsup|5>+1.389*10<rsup|\<um\>3>*z<rsup|6>+1.984*10<rsup|\<um\>4>*z<rsup|7>+2.480*10<rsup|\<um\>5>*z<rsup|8>+2.756*10<rsup|\<um\>6>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
              <right-flush> <math|<with|color|brown|mode|text|Analytic>>
            </folded-io-math>

            <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
              exp(z)[int 20];
            <|folded-io-math>
              <math|4.110*10<rsup|\<um\>19>> <right-flush>
              <math|<with|color|brown|mode|text|Complex>>
            </folded-io-math>

            <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
              \;
            </input-math>
          </folded>

          <\folded>
            Analytic continuation
          <|folded>
            <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
              \<ell\>:Analytic\<longequal\>log(1-z);
            </input-math>

            <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
              radius(\<ell\>);
            <|folded-io-math>
              <math|9.99937726184725761359*10<rsup|\<um\>1>> <right-flush>
              <math|<with|color|brown|mode|text|Floating>>
            </folded-io-math>

            <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
              evaluate(\<ell\>,complex(1/2));
            <|folded-io-math>
              <math|\<um\>6.931*10<rsup|\<um\>1>> <right-flush>
              <math|<with|color|brown|mode|text|Complex>>
            </folded-io-math>

            <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
              continuate(\<ell\>,complex(1/2));
            <|folded-io-math>
              <math|\<um\>6.931*10<rsup|\<um\>1>-2.000*z-2.000*z<rsup|2>-2.667*z<rsup|3>-4.000*z<rsup|4>-6.400*z<rsup|5>-1.067*10<rsup|1>*z<rsup|6>-1.829*10<rsup|1>*z<rsup|7>-3.200*10<rsup|1>*z<rsup|8>-5.689*10<rsup|1>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
              <right-flush> <math|<with|color|brown|mode|text|Analytic>>
            </folded-io-math>

            <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
              continuate(\<ell\>,turn(complex(1)));
            <|folded-io-math>
              <math|6.283*\<mathi\>-1.000*z-5.000*10<rsup|\<um\>1>*z<rsup|2>-3.333*10<rsup|\<um\>1>*z<rsup|3>-2.500*10<rsup|\<um\>1>*z<rsup|4>-2.000*10<rsup|\<um\>1>*z<rsup|5>-1.667*10<rsup|\<um\>1>*z<rsup|6>-1.429*10<rsup|\<um\>1>*z<rsup|7>-1.250*10<rsup|\<um\>1>*z<rsup|8>-1.111*10<rsup|\<um\>1>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
              <right-flush> <math|<with|color|brown|mode|text|Analytic>>
            </folded-io-math>

            <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
              \;
            </input-math>
          </folded>

          <\session|mathemagix|default>
            <\folded>
              Differential equations
            <|folded>
              <\textput>
                <\equation*>
                  f<rprime|''>=(z<rsup|2>+1)*f<rprime|'>+\<mathe\><rsup|z>*f;<space|2em>f(0)=1,f<rprime|'>(0)=1+2*\<mathi\>.
                </equation*>
              </textput>

              <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
                f:Analytic\<longequal\>solve_lde((z<rsup|2>+1,exp(z)),(complex(1),complex(1,2)));
              </input-math>

              <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
                f;
              <|folded-io-math>
                <math|1.000+<left|(>1.000+2.000*\<mathi\><right|)>*z+<left|(>1.000+1.000*\<mathi\><right|)>*z<rsup|2>+<left|(>6.667*10<rsup|\<um\>1>+1.000*\<mathi\><right|)>*z<rsup|3>+<left|(>5.417*10<rsup|\<um\>1>+5.833*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|4>+<left|(>3.500*10<rsup|\<um\>1>+4.833*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|5>+<left|(>2.278*10<rsup|\<um\>1>+2.750*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|6>+<left|(>1.343*10<rsup|\<um\>1>+1.742*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|7>+<left|(>7.882*10<rsup|\<um\>2>+9.767*10<rsup|\<um\>2>*\<mathi\><right|)>*z<rsup|8>+<left|(>4.361*10<rsup|\<um\>2>+5.572*10<rsup|\<um\>2>*\<mathi\><right|)>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
                <right-flush> <math|<with|color|brown|mode|text|Analytic>>
              </folded-io-math>

              <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
                u:Complex\<longequal\>evaluate(f,complex(1/10));
              </input-math>

              <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
                u;
              <|folded-io-math>
                <math|1.111+2.111*10<rsup|\<um\>1>*\<mathi\>> <right-flush>
                <math|<with|color|brown|mode|text|Complex>>
              </folded-io-math>

              <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
                approximate(u,1.0e\<um\>81);
              <|folded-io-math>
                <math|1.11072457537794457102292725574830566357052541308848196626687047567517902828392834+2.1106346012282867466007605052618438398248510727864880851400427655460836641117663*10<rsup|\<um\>1>*\<mathi\>>
                <right-flush> <math|<with|color|brown|<text|Complexify><left|(><text|Interval><right|)>>>
              </folded-io-math>

              <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
                \;
              </input-math>
            </folded>
          </session>
        </session>
      </session>
    </fold-back>

    \;
  </hidden>|<\hidden>
    <tit|Transversal tools>

    <\itemize>
      <item>Undo / Redo.

      <item>Remote tools.

      <item>Presentation mode.

      <item>Conversions.

      <item>Structured editing (search, variants, navigation, <abbr|etc.>).
    </itemize>
  </hidden>|<\hidden>
    <tit|Style files>

    <math|<inactive|<assign|cd|<macro|A|B|C|D|<tabular*|<tformat|<table|<row|<cell|<arg|A>>|<cell|\<longrightarrow\>>|<cell|<arg|B>>>|<row|<cell|\<longdownarrow\>>|<cell|>|<cell|\<longdownarrow\>>>|<row|<cell|<arg|C>>|<cell|\<longrightarrow\>>|<cell|<arg|D>>>>>>>>>>

    <\equation*>
      <cd|A\<oplus\>B|X|Y|C\<otimes\>D>
    </equation*>

    \;
  </hidden>|<\hidden>
    <tit|The <name|Scheme> extension language>

    <\equation*>
      a+<frac|a+b|<sqrt|x+y>>+c
    </equation*>

    <\session|scheme|default>
      <\input|scheme] >
        (select (buffer-tree) '(<with|color|magenta|:*>
        (<with|color|magenta|:match> (<with|color|dark blue|frac>
        <with|color|magenta|:%1> (<with|color|dark blue|sqrt>
        <with|color|magenta|:%1>)))))
      </input>

      <\input|scheme] >
        (define t

        \ \ (car (select (buffer-tree)

        \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ '(<with|color|magenta|:*>
        (<with|color|magenta|:match> (<with|color|dark blue|frac>
        <with|color|magenta|:%1> (<with|color|dark blue|sqrt>
        <with|color|magenta|:%1>)))))))
      </input>

      <\input|scheme] >
        (tree-set! t `(<with|color|dark blue|frac> ,(tree-ref t 1) ,(tree-ref
        t 0)))
      </input>

      <\input|scheme] >
        (tm-define (kbd-return)

        \ \ (<with|color|magenta|:inside> <with|color|dark blue|frac>)

        \ \ (with-innermost t '<with|color|dark blue|frac>

        \ \ \ \ (tree-set! t `(<with|color|dark blue|frac> ,(tree-ref t 1)
        ,(tree-ref t 0)))

        \ \ \ \ (tree-go-to t 0 :start)))
      </input>

      <\input|scheme] >
        \;
      </input>
    </session>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|language|english>
    <associate|page-screen-top|5mm>
    <associate|prog-scripts|maxima>
    <associate|sfactor|5>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|tfin-t-bound|<tuple|1|?>>
  </collection>
</references>